<template>
    <div class="container is-fluid">

        <form action="#" v-if="onCart">
        <div class="columns">
          <div class="column is-3">
          <div class="field-label is-normal">
              <label for="name" class="label">calcule prazo e frete</label>
          </div>
          </div>
          <div class="column is-4">
              <div class="field has-addons">
              <div class="field control">
                <b-field :addons="false">
                    <b-input
                        placeholder="Entre com o CEP"
                        v-model="cep"
                        v-mask="'##.###-###'"
                        @input.native="onInput"
                        class="txtCep">
                    </b-input>
                </b-field>

              </div>

              <div class="control">
                  <button class="button is-link" @click.prevent="loadFrete(cep)">calcular</button>
              </div>
              </div>
          </div>
          <div class="column is-2">
              <a href="http://www.buscacep.correios.com.br/sistemas/buscacep/" class="buscaCep" target="_blank">
                  não sei meu cep
              </a>
          </div>
        </div>
    </form>

    <div v-if="fretes">
        <b-notification ref="fretes" :closable="false">
            <h1 class="title is-5">opções de entrega</h1>

            <div class="columns">

                <ShippingOverviewOptions v-for="(frete, index) in fretes"
                    :key="index"
                    :frete="frete"
                    @changed="changed"
                />

            </div>
        </b-notification>
        <!--
        <FreteModal
            v-show="showModal"
            :showModal="showModal"
            @close="showModal = false"
        >teste</FreteModal>
        -->
    </div>
  </div>

</template>
<script>
import { mapGetters, mapActions } from 'vuex';
import ShippingOverviewOptions from '@/components/cart/ShippingOverviewOptions';
import FreteModal from '@/components/cart/FreteModal';

import queryString from 'query-string';

const convert = require('xml-js');

export default {
    components: {
        ShippingOverviewOptions,
        FreteModal
    },
    data() {
        return {
          radio: '',
            cep: '',
            rawCep: '',
            masks: {
                maskCep: {
                    delimiters: ['.', '-'],
                    blocks: [2, 3, 3],
                    numericOnly: true
                }
            },
            servicosCorreio: [ '04014', '04510' ],
            showModal: false,
            onCart: true,
            correiosData: {
                nCdServico: null,
                sCepOrigem: '68903359',
                sCepDestino: '',
                nVlPeso: 1,
                nCdFormat: 1,
                nVlComprimento: 20,
                nVlAltura: 20,
                nVlLargura: 20,
                nVlDiametro: 0,
                sCdMaoPropria: 'n',
                nVlValorDeclarado: 0,
                sCdAvisoRecebimento: 'n',
                StrRetorno: 'xml'
            }
        }
    },

    mounted() {
        if (localStorage.cep){
            this.cep = localStorage.cep;
            this.getShippingPrice(localStorage.cep);
        }
    },

    watch: {
        cep(newCep){
            localStorage.cep = newCep;
        }
    },

    methods: {
        ...mapActions({
            setService: 'correios/setService',
            clearService: 'correios/clearServices',
        }),

        onInput(event){
            this.rawCep = event.target.value;
            this.cep = event.target.value;
        },

        async changed(value){
            // localStorage.frete = value
            this.$emit('shippingValue', value);
        },

        async loadFrete(cep){
            localStorage.frete = '';
            this.$emit('shippingValue', 0);
            this.getShippingPrice(cep);
        },

        async getShippingPrice(cep) {
            this.clearService();

            const loadingComponent = this.$buefy.loading.open({
                container: this.$refs.fretes.$el
                // container: document.querySelector('.fretes').$el
            })

            const getData = async () => {
                await this.servicosCorreio.map(async (data) =>{
                    this.correiosData.nCdServico = data;
                    this.correiosData.sCepDestino = cep;
                    let promises = await this.$axios.$post(`/api1/?${queryString.stringify(this.correiosData)}`)
                    .then((response) => {
                        var result = convert.xml2js(response, {compact: true});

                        let envios = Object.keys(result.Servicos.cServico).map(item => {
                            return result.Servicos.cServico[item]._text;
                        })

                        let enviosPronto = {
                            'Codigo': envios[0],
                            'Valor': envios[1],
                            'PrazoEntrega': envios[2]
                        }

                        return enviosPronto;

                    })
                    this.setService(promises);
                })
            }

            getData().then(data => {
                loadingComponent.close();
            })

        },
        async storeShippings(data){
            let shippingInfo = {
                name: data.Codigo === '04510' ? 'PAC' : 'SEDEX',
                delivery_time: data.PrazoEntrega,
                price: data.Valor.replace(",", "")
            }
            // let response =  await this.$axios.$post('/app/shipping-methods', shippingInfo)
        }
    },

    computed: {
        ...mapGetters({
            fretes: 'correios/service'
        })
    },
}
</script>
<style scoped>
    .container {
        margin-top: 10px;
        padding-top: 10px;
        margin-left: auto;
        background-color: #FFF;
    }

    a.buscaCep {
        text-decoration: none;
        font-size: .8em;
    }

    .txtCep {
        font-size: 2em
    }

    .label {
        font-size: .9em;
        font-weight: normal;
    }

    .title {
        margin-bottom: 10px;
    }
</style>>
